module Proxtopus
  class ProxySet < Array
    
    def push(proxy)
      #puts proxy.class
      if !proxy.is_a?(Proxtopus::Proxy) && !proxy.is_a?(Proxtopus::ProxySet) && !proxy.is_a?(Hash)
        raise ArgumentError, "A ProxySet may only contain Proxy, ProxySet, or Hash objects!"
      end
      
      if !proxy.is_a?(Proxtopus::ProxySet)
        if proxy.is_a?(Hash)
          proxy = Proxy.new(proxy['host'], proxy['port'], proxy['protocol'], proxy['country'], proxy['anonymity'])
        end
        
        super(proxy) if !include?(proxy)
      else
        proxy.each { |p| super(p) }
      end
      self
    end
    
    def shift(proxy)
      if !proxy.is_a?(Proxtopus::Proxy) && !proxy.is_a?(Hash)
        raise ArgumentError, "A ProxySet may only contain Proxy or Hash objects!"
      end
     
      if !proxy.is_a?(Proxtopus::ProxySet) 
        if proxy.is_a?(Hash)
          proxy = Proxy.new(proxy['host'], proxy['port'], proxy['protocol'], proxy['country'], proxy['anonymity'])
        end
        
        super(proxy) if !include?(proxy)
      else
        proxy.each { |p| super(p) }
      end
      self
    end
    
    def include?(proxy)
      if proxy.is_a?(Proxtopus::Proxy)
        each do |p|
          return true if proxy == p
        end
        false
      else
        false
      end
    end
    
  end
end